//GRENDER GAMES


#include "mapa.h"

#include <iostream>

using namespace std;

// Constructor Parametrizado
Mapa::Mapa() {
   for (int i = 0; i < K_FILA; i++) {
      for (int j = 0; j < K_COLUMNA; j++) {
          mapa[i][j]=' ';
      }
   }
}

void Mapa::inicio(Nave nave) {
   for (int i = 0; i < K_FILA; i++) {
      for (int j = 0; j < K_COLUMNA; j++) {
          if ((i==0)||(i==K_FILA-1)) mapa[i][j] = '-';
      }
   }
   
   switch (nave.getForma().getNumPuntos()) {
      case 4: 
           mapa[12][0] = 'T';
           mapa[11][0] = '*';
           mapa[13][0] = '*';
           mapa[12][1] = '>';
           break;
      
      case 5: 
           mapa[12][0] = '*';
           mapa[12][1] = 'O';
           mapa[12][2] = '*';
           mapa[11][1] = '*';
           mapa[13][1] = '*';
           break;
      case 6:
			mapa[12][0] = '^';
			mapa[12][1] = 'O';
			mapa[12][2] = '^';
			mapa[11][1] = '_';
			mapa[13][1] = 'v';
			break;
   }
   
}

void Mapa::putMonstruo2Mapa(Monstruo2 &M,StdPijo stdp){
	int cX = 0;
	int cY = 0;

	cX = M.getPosicion().getX();
	cY = M.getPosicion().getY();


	if(!M.getSentido()){
		if(cX != 3){
			M.putRealizado(false);
			M.putPosicion(cX-1,cY);
		}else if((cX == 3) && (!M.getRealizado())){
			M.putRealizado(true);
			M.putPosicion(cX,cY-2);
			M.putSentido(true);
		}
	}else{
		if(cX != 21){
			M.putRealizado(false);
			M.putPosicion(cX+1,cY);
		}else if((cX == 21) && (!M.getRealizado())){
			M.putRealizado(true);
			M.putPosicion(cX,cY-2);
			M.putSentido(false);
		}
	}


		cX = M.getPosicion().getX();
		cY = M.getPosicion().getY();

		for (int i = 0; i < K_FILA; i++) {
				for (int j = 0; j < K_COLUMNA; j++) {
				   if ((cX==i)&&(cY==j)) {
					  if  (M.getForma().getNumPuntos() == 6) { // Tri�ngulo
						 mapa[cX][cY] = 'O';
						 mapa[cX][cY-1] = '^';
						 mapa[cX][cY+1] = '^';
						 mapa[cX-1][cY] = 'v';
						 mapa[cX+1][cY] = '_';
				  }
			   }
			}
		 }
}

void Mapa::putMonstruoMapa(Monstruo1 &M,StdPijo stdp){
	int cX = 0;
	int cY = 0;

	cX = M.getPosicion().getX();
	cY = M.getPosicion().getY();




	if (movimientoPermitido(cX,cY-1,M.getForma().getNumPuntos())) M.putPosicion(cX,cY-1);

	cX = M.getPosicion().getX();
	cY = M.getPosicion().getY();

	for (int i = 0; i < K_FILA; i++) {
	        for (int j = 0; j < K_COLUMNA; j++) {
	           if ((cX==i)&&(cY==j)) {
	              if  (M.getForma().getNumPuntos() == 4) { // Tri�ngulo
	                 mapa[i][j] = 'T';
	                 mapa[i][j+1] = '>';
	                 mapa[i-1][j] = '*';
	                 mapa[i+1][j] = '*';


	              }else if (M.getForma().getNumPuntos() == 5) { // Cuadrado
	                 mapa[cX][cY] = 'O';
	                 mapa[cX][cY-1] = '*';
	                 mapa[cX][cY+1] = '*';
	                 mapa[cX-1][cY] = '*';
	                 mapa[cX+1][cY] = '*';
	              }
	           }
	        }
	     }
}

void Mapa::putNaveMapa(Nave &nave, char tecla,StdPijo stdp){
     int cX = 0;
     int cY = 0;

     // Coordenada de Origen
     cX = nave.getPosicion().getX();
     cY = nave.getPosicion().getY();
     //cout << "\nPosicion de la nave antes de moverla " << cX << ", " << cY << "\n";
     
     switch (tecla) {
        case KUP: if (movimientoPermitido(cX-1, cY, nave.getForma().getNumPuntos())) nave.putPosicion(cX-1,cY);break;
        case KDOWN: if (movimientoPermitido(cX+1, cY, nave.getForma().getNumPuntos())) nave.putPosicion(cX+1,cY);break;
        case KRIGHT: if (movimientoPermitido(cX, cY+1, nave.getForma().getNumPuntos())) nave.putPosicion(cX,cY+1);break;
        case KLEFT: if (movimientoPermitido(cX, cY-1, nave.getForma().getNumPuntos())) nave.putPosicion(cX,cY-1);break;
        case 0:     if (movimientoPermitido(cX, cY, nave.getForma().getNumPuntos())) nave.putPosicion(cX,cY);

        break;
     }
     // Coordenada de Destino.
     cX = nave.getPosicion().getX();
     cY = nave.getPosicion().getY();
     //cout << "\nPosicion de la nave despu�s de moverla " << cX << ", " << cY << "\n";
     // Comprobar que el movimiento est� permitido antes de Dibujar la Nave en la nueva posicion.
     
     
     // Dibujar Nave en el mapa.
     for (int i = 0; i < K_FILA; i++) {
        for (int j = 0; j < K_COLUMNA; j++) {
           if ((cX==i)&&(cY==j)) {
              if  (nave.getForma().getNumPuntos() == 4) { // Tri�ngulo
                 mapa[i][j] = 'T';
                 mapa[i][j+1] = '>';
                 mapa[i-1][j] = '*';
                 mapa[i+1][j] = '*';
                         
                                
              }else if (nave.getForma().getNumPuntos() == 5) { // Cuadrado
                 mapa[cX][cY] = 'O';
                 mapa[cX][cY-1] = '*';
                 mapa[cX][cY+1] = '*';
                 mapa[cX-1][cY] = '*';
                 mapa[cX+1][cY] = '*';     
              }
           }
        }
     }
}

// Función que devuelve si un Movimiento es válido
bool Mapa::movimientoPermitido(int f, int c, int nPuntos) {
     //cout << "\nPosicion de la nave destino: " << f << ", " << c << " Puntos: " << nPuntos << "\n";
     if (nPuntos == 4) { //Triángulo
        if ((f-2 < 0)||(f+2 >= K_FILA)||(c < 0)||(c+1 >= K_COLUMNA)) return false;
     }else if (nPuntos == 5) { //Cuadrado
        if ((f-2 < 0)||(f+2 >= K_FILA)||(c-1 < 0)||(c+1 >= K_COLUMNA)) return false;
     }
     
     return true;
}

void Mapa::limpiar_mapa(){
	for (int i=0; i < K_FILA; i++) {
	    for (int j=0; j < K_COLUMNA; j++) {
	        mapa[i][j] = ' ';
	    }
	}
}

void Mapa::delNaveMapa(Nave &nave) {
     int cX = 0;
     int cY = 0;
     
     cX = nave.getPosicion().getX();
     cY = nave.getPosicion().getY();
     //cout << "\nPosicion de la nave antes de limpiar " << cX << ", " << cY << "\n";
     if  (nave.getForma().getNumPuntos() == 4) { // Tri�ngulo
         mapa[cX][cY] = ' ';
         mapa[cX][cY+1] = ' ';
         mapa[cX-1][cY] = ' ';
         mapa[cX+1][cY] = ' ';         
                        
     }else if (nave.getForma().getNumPuntos() == 5) { // Cruz
         mapa[cX][cY] = ' ';
         mapa[cX][cY-1] = ' ';
         mapa[cX][cY+1] = ' ';
         mapa[cX-1][cY] = ' ';
         mapa[cX+1][cY] = ' ';     
     }
}

void Mapa::delMonstruoMapa(Nave &M) {
     int cX = 0;
     int cY = 0;

     cX = M.getPosicion().getX();
     cY = M.getPosicion().getY();
     //cout << "\nPosicion de la nave antes de limpiar " << cX << ", " << cY << "\n";
     if  (M.getForma().getNumPuntos() == 4) { // Tri�ngulo
         mapa[cX][cY] = ' ';
         mapa[cX][cY+1] = ' ';
         mapa[cX-1][cY] = ' ';
         mapa[cX+1][cY] = ' ';

     }else if (M.getForma().getNumPuntos() == 6) { // Cruz
         mapa[cX][cY] = ' ';
         mapa[cX][cY-1] = ' ';
         mapa[cX][cY+1] = ' ';
         mapa[cX-1][cY] = ' ';
         mapa[cX+1][cY] = ' ';
     }
}

void Mapa::putDisparo(int dX, int dY) {
     mapa[dX][dY] = '-';
}

void Mapa::delRastro(int dX, int dY) {
     mapa[dX][dY] = ' ';
     //cout << "\nPosiciones al Borrar por la derecha: " << dX << ", " << dY << "\n";
}

void Mapa::delRastroLeft(int dX, int dY) {
     if (mapa[dX][dY] != ' ');
     //cout << "\nPosiciones antes de calcular la longitud: " << dX << ", " << dY << "\n";
     while (mapa[dX][dY] != ' ') {
           dY++;
     }
     //cout << "\nPosiciones despues de calcular la longitud: " << dX << ", " << dY << "\n";
     for (int pos=0; pos < dY; pos++) {
         mapa[dX][pos] = mapa[dX][pos+1];
     }
     mapa[dX][dY-1] = ' ';
}

void Mapa::delDecorado(int x, int y, char* obj) {
    for (int i=0; ((y<K_COLUMNA)&&(i<strlen(obj)));i++) {
        mapa[x][y] = ' ';
        y++;
    }    
}

void Mapa::putDecorado(int x, int y, char* obj) {
    for (int i=0; ((y<K_COLUMNA)&&(i<strlen(obj)));i++) {
        mapa[x][y] = obj[i];
        y++;
    }    
}

void Mapa::visualizar(StdPijo stdp) {
   for (int i = 0; i < K_FILA; i++) {
      for (int j = 0; j < K_COLUMNA; j++) {
          stdp.writeChar(mapa[i][j]);
      }
   }
}


bool Mapa::colision(int x, int y,Nave nave){

	bool colision = false;

	if((x == nave.getPosicion().getX()) && (y == nave.getPosicion().getY())) colision = true;

	return colision;


}
                 
